/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: FileIDFunc.cpp,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#include <iostream>
#include <vector>
#include <string>

/* IdMgr library */
#include "ServerCommon.h"
#include "DataRetainer.h"

using namespace OpenSOAP;
using namespace std;

/* SOAP bZ[WɑΉt@C ID 擾 */
string
convertToFileID(const string& message, const string& spoolPath)
{
#ifdef DEBUG_
  cerr << "message = " << message << endl;
#endif

  string fileID;
  
  //DataRetainer CX^X
  OpenSOAP::DataRetainer* writer = new OpenSOAP::DataRetainer(spoolPath);

  //DataContainer CX^X
  OpenSOAP::DataContainer dataCont;

  //f[^()Zbg
  dataCont.setData(message);

  //f[^putɐIdU
  int result = writer->put(dataCont);
  if (0 > result) {
    //error proc.
    // ...
    cerr << "put failed" << endl;
    delete writer;
    //return NULL;
    return "";
  }

#ifdef DEBUG_
  cerr << "create DataFile writer finish" << endl;
#endif

  fileID = dataCont.getId().toString();

#ifdef DEBUG_
  cerr << "write id=[" << fileID << "]" << endl;
#endif

  delete writer;

  return fileID;
}

/* t@C ID ɑΉ SOAP bZ[W擾 */
string
revertFromFileID(const string& fileID, const string& spoolPath) {

  //DataRetainer CX^X
  OpenSOAP::DataRetainer* reader = new OpenSOAP::DataRetainer(spoolPath);
  
  //DataContainer CX^X
  OpenSOAP::DataContainer readDataCont;
  
  //MIdZbgAΉf[^ǂݍ
  readDataCont.setId(fileID);
  
  //f[^getɐƃf[^ǂݍ܂
  int result = reader->get(readDataCont);
  if (0 > result) {
    //error proc.
    // ...
    cerr << "get failed" << endl;
    return "";
  }
  
  //ǂݍ񂾃f[^(SOAPbZ[W)擾
  string message = readDataCont.getData();

  delete reader;

  return message;
}

/* t@C ID ɑΉ SOAP bZ[W̓eXV */
int
updateFileIDContent(const string& fileID, 
		    const string& message,
		    const string& spoolPath) {

  //DataRetainer CX^X
  OpenSOAP::DataRetainer* updater = new OpenSOAP::DataRetainer(spoolPath);
  
  //DataContainer CX^X
  OpenSOAP::DataContainer dataCont;

  //f[^()Zbg
  dataCont.setData(message);

  //MIdZbgAΉf[^ǂݍ
  dataCont.setId(fileID);
  
  //f[^getɐƃf[^ǂݍ܂
  int result = updater->update(dataCont);
  if (0 > result) {
    //error proc.
    // ...
    cerr << "update failed" << endl;
  }
  delete updater;

  return result;
}

