/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: SSMLAttrMgr.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef SSMLAttrMgr_H
#define SSMLAttrMgr_H

#if defined(WIN32)
#include <windows.h>
#else
#include <pthread.h>
#endif

#include <string>
#include <list>
#include <libxml/tree.h>

namespace OpenSOAP {

  class SSMLAttrMgr {

    static const std::string SSML_FILE_SUFFIX; // = "ssml";

  public:
    SSMLAttrMgr();
    virtual ~SSMLAttrMgr();

    //ʐMJn
    int run();

  private:
    //f[^̃[h̃bN
#if defined(WIN32)
	HANDLE
#else
    pthread_mutex_t
#endif
		loadXmlLock_;

#if defined(WIN32)
	int 
#else
    //UNIXhC\PbgAhX
    std::string 
#endif
		socketAddr_;

    //ǂݍݑΏXMLt@CfBNg
    std::string xmlDir_;

    //DOMf[^̃Xg
    std::list<xmlDocPtr> xmlList_;

    //XMLt@C̓ǂݍ
    int loadXml();
	bool addXmlList(const std::string& ssmlFilePath);

    //ʐM
    static 
#if defined(WIN32)
	void
#else
	void* 
#endif
	connectionThread(void* arg);
    void connectProc(int sockfd);

    //for shm buffer
#if defined(WIN32)
	HANDLE shmMap;
	int createShm();
	void deleteShm();
#endif
    void clearShm();
    void addShm(const std::string& query, const std::string& value);
#if defined(WIN32)
	HANDLE
#else
    int 
#endif
		semid_; // SEM ID

    //  public: // for test
    std::string queryXml(const std::string& query);

    typedef struct ThrDataTag {
      SSMLAttrMgr* that;
      int sockfd;
    } ThrData;
  };

} // end of namespace OpenSOAP


#endif /* SSMLAttrMgr_H */
