/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: SrvConfAttrMgr.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef SrvConfAttrMgr_H
#define SrvConfAttrMgr_H

#include <string>
#if defined(WIN32)
#include <windows.h>
#else
#include <pthread.h>
#endif
#include <list>
#include <libxml/tree.h>

#include "SrvConf.h"

namespace OpenSOAP {

  class SrvConfAttrMgr : public SrvConf {

  public:
    SrvConfAttrMgr();
    virtual ~SrvConfAttrMgr();

    //ʐMJn
    int run();

  private:
    //f[^̃[h̃bN
#if defined(WIN32)
    HANDLE
#else
    pthread_mutex_t
#endif
    loadXmlLock_;
    //pthread_cond_t  ;

#if defined(WIN32)
    int
#else
    //UNIXhC\PbgAhX
    std::string 
#endif
    socketAddr_;

    //ǂݍݑΏXMLt@CfBNg
    //std::string xmlDir_;

    //DOMf[^̃Xg
    //std::list<xmlDocPtr> xmlList_;

    //XMLt@C̓ǂݍ
    int reloadXml();

    //xmlList_DOM\J
    //void freeXmlList();

    //ʐM
    static 
#if defined(WIN32)
    void
#else
    void* 
#endif
    connectionThread(void* arg);
    void connectProc(int sockfd);

    //for shm buffer
#if defined(WIN32)
    HANDLE shmMap;
    int createShm();
    void deleteShm();
#endif
    void clearShm();
    void addShm(const std::string& query, const std::string& value);
#if defined(WIN32)
    HANDLE
#else
    int 
#endif
    semid_; // SEM ID

    //  public: // for test
    std::string queryXml(const std::string& queryStr);

    typedef struct ThrDataTag {
      SrvConfAttrMgr* that;
      int sockfd;
    } ThrData;
  };

} // end of namespace OpenSOAP


#endif /* SrvConfAttrMgr_H */
